package org.wyzc.entity;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.util.LinkedList;
import org.wyzc.Listener.SnakeListener;
import org.wyzc.util.Global;
public class Snake {
	private SnakeListener snakeListener;
	private boolean isLife=true;
	private LinkedList<Point> body = new LinkedList<Point>();
    public static final int UP=1;
    public static final int DOWN=-1;
    public static final int LEFT=3;
    public static final int RIGHT=-3;
//    private int direction;//洢ǰ
    private int oldDirection,newDirection;
    private Point tail;
	public Snake() {
		init();
	}
	private void init() {
		int x = Global.WIDTH / 2;
		int y = Global.HEIGHT / 2;
		for (int i = 0; i < 3; i++) {
			body.add(new Point(x - i, y));
		}
//		this.direction=RIGHT;
		this.oldDirection=this.newDirection=RIGHT;
	}
	public void move() {
		tail=body.removeLast();
		int x=body.getFirst().x;
		int y=body.getFirst().y;
	//	switch(direction){
		if(this.oldDirection+this.newDirection!=0)
		this.oldDirection=this.newDirection;
		switch(oldDirection){
		case UP:
		y--;
		if(y<0) y=Global.HEIGHT-1;
		break;
		case DOWN:
		y++;
		if(y>=Global.HEIGHT) y=0;
		break;
		case LEFT:
		x--;
		if(x<0) x=Global.WIDTH-1;
		break;
		case RIGHT:
		x++;
		if(x>=Global.WIDTH) x=0;
		break;
		}
		body.addFirst(new Point(x,y));
		System.out.println("ƶ");
	}
	public void eatFood(Food food) {
		body.addLast(tail);
		System.out.println("ڳʳ");
	}
	public void changeDirection(int direction) {
	//	if(this.direction+direction!=0)
	//	this.direction=direction;
		this.newDirection=direction;
		System.out.println("ڸı䷽");
	}
	public void drawMe(Graphics g) {
		System.out.println("ڻԼ");
		g.setColor(Color.blue);
		for (Point p : body) {
			g.fill3DRect(p.x * Global.CELL_SIZE, p.y * Global.CELL_SIZE,Global.CELL_SIZE, Global.CELL_SIZE, true);
		}
	}
	public boolean isEatSelf() {
		for(int i=1;i<body.size();i++){
			if(body.get(i).equals(getHead())){
				return true;
			}
		}
		return false;
	}
	public void addSnakeListener(SnakeListener snakeListener) {
		if (snakeListener != null)
			this.snakeListener = snakeListener;
	}
	public void start() {
		new SnakeDriver().start();
	}
    public Point getHead(){
    	return body.getFirst();
    }
	public void setLife(boolean isLife) {
		this.isLife = isLife;
	}
	private class SnakeDriver extends Thread {
		public void run() {
			while (isLife) {
				move();
				snakeListener.snakeMoved(Snake.this);
				try {
					Thread.sleep(300);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
	}
}